import { ValidateBy, ValidationOptions, buildMessage } from 'class-validator';
import { hasValidPositionIndexes } from '../has-valid-position-indexes.validator';
import { WaypointDto } from '../../waypoint.dto';

export const HasValidPositionIndexes = (
  validationOptions?: ValidationOptions,
): PropertyDecorator =>
  ValidateBy(
    {
      name: '',
      constraints: [],
      validator: {
        validate: (waypoints: WaypointDto[]): boolean =>
          hasValidPositionIndexes(waypoints),
        defaultMessage: buildMessage(
          () => `invalid waypoints positions`,
          validationOptions,
        ),
      },
    },
    validationOptions,
  );
